#include <genlib.h> 
main() 
{
DEF_LOFIG("time_relechip"); 
LOCON("A[3:0]", IN, "A[3:0]"); /* lower BCD digit */ 
LOCON("B[3:0]", IN, "B[3:0]"); /* higher BCD digit */ 
LOCON("reset", IN, "reset" ); /* reset signal */ 
LOCON("clk", IN, "clk" ); /* clock input */
LOCON("enable", IN, "enable" ); /* enable signal */
LOCON("alarm", OUT, "alarm"); /* alarm output */  
LOCON("vdd", IN, "vdd" ); /* core power supply */ 
LOCON("vss", IN, "vss" ); /* core ground */ 
LOCON("vdde", IN, "vdde" ); /* pads power supply */ 
LOCON("vsse", IN, "vsse" ); /* pads ground */ 



LOINS("pi_sp", "p_a0","A[0]", "inreg1[0]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_a1","A[1]", "inreg1[1]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_a2","A[2]", "inreg1[2]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_a3","A[3]", "inreg1[3]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_b0","B[0]", "inreg2[0]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_b1","B[1]", "inreg2[1]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_b2","B[2]", "inreg2[2]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_b3","B[3]", "inreg2[3]","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pi_sp", "p_res","reset", "res","cki", "vdde", "vdd", "vsse", "vss", 0);
LOINS("pck_sp", "clk0", "clk", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("pvssick_sp", "clk1","clock", "cki","vdde", "vdd", "vsse", "vss", 0);  
LOINS("pi_sp", "p_en","enable", "en","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("po_sp", "p_al","alarma", "alarm","cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvsse_sp", "gnd0e", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvsse_sp", "gnd1e", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvdde_sp", "pwr0e", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvdde_sp", "pwr1e", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvssi_sp", "gnd0i", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS ("pvddi_sp", "pwr0i", "cki", "vdde", "vdd", "vsse", "vss", 0); 
LOINS("time_releopt", "core","inreg1[3:0]", "inreg2[3:0]","res","clock","en", 
"alarma", "vdd", "vss", 0); 
SAVE_LOFIG(); 
exit(0); /* necessary for the proper run of the Makefile */ 
} 
