//
// Projet Mips R3000 2000/2001
// 31/10/00

# include  <genlib.h>
# include  <dpgen.h>
extern int main()

{       

/*************************** NETLIST DESCRIPTION ***************************/
  GENLIB_DEF_LOFIG ("mips_dpt");
  
  GENLIB_LOCON ("vdd"           ,IN        ,"vdd");
  GENLIB_LOCON ("vss"           ,IN        ,"vss");
  GENLIB_LOCON ("pc_test"       ,IN        ,"pc_test");
  GENLIB_LOCON ("ad_test"       ,IN        ,"ad_test");
  GENLIB_LOCON ("epc_test"      ,IN        ,"epc_test");
  GENLIB_LOCON ("bar_test"      ,IN        ,"bar_test");
  GENLIB_LOCON ("hi_test"       ,IN        ,"hi_test");
  GENLIB_LOCON ("lo_test"       ,IN        ,"lo_test");
  GENLIB_LOCON ("ir_test"       ,IN        ,"ir_test");
  GENLIB_LOCON ("dt_test"       ,IN        ,"dt_test");
  GENLIB_LOCON ("pc_scin"       ,IN        ,"pc_scin");
  GENLIB_LOCON ("ad_scin"       ,IN        ,"ad_scin");
  GENLIB_LOCON ("epc_scin"      ,IN        ,"epc_scin");
  GENLIB_LOCON ("ir_scin"       ,IN        ,"ir_scin");
  GENLIB_LOCON ("bar_scin"      ,IN        ,"bar_scin");
  GENLIB_LOCON ("hi_scin"       ,IN        ,"hi_scin");
  GENLIB_LOCON ("lo_scin"       ,IN        ,"lo_scin");
  GENLIB_LOCON ("dt_scin"       ,IN        ,"dt_scin");
  GENLIB_LOCON ("pc_scout"      ,OUT       ,"pc_scout");
  GENLIB_LOCON ("ad_scout"      ,OUT       ,"ad_scout");
  GENLIB_LOCON ("epc_scout"     ,OUT       ,"epc_scout");
  GENLIB_LOCON ("bar_scout"     ,OUT       ,"bar_scout");
  GENLIB_LOCON ("dt_scout"      ,OUT       ,"dt_scout");
  GENLIB_LOCON ("hi_scout"      ,OUT       ,"hi_scout");
  GENLIB_LOCON ("lo_scout"      ,OUT       ,"lo_scout");
  GENLIB_LOCON ("ir_scout"      ,OUT       ,"ir_scout");
  GENLIB_LOCON ("pc_ck"         ,IN        ,"pc_ck");
  GENLIB_LOCON ("ad_ck"         ,IN        ,"ad_ck");
  GENLIB_LOCON ("epc_ck"        ,IN        ,"epc_ck");
  GENLIB_LOCON ("bar_ck"        ,IN        ,"bar_ck");
  GENLIB_LOCON ("ir_ck"         ,IN        ,"ir_ck");
  GENLIB_LOCON ("dt_ck"         ,IN        ,"dt_ck");
  GENLIB_LOCON ("hi_ck"         ,IN        ,"hi_ck");
  GENLIB_LOCON ("lo_ck"         ,IN        ,"lo_ck");
  GENLIB_LOCON ("pc_wen"        ,IN        ,"pc_wen");
  GENLIB_LOCON ("ad_wen"        ,IN        ,"ad_wen");
  GENLIB_LOCON ("epc_wen"       ,IN        ,"epc_wen");
  GENLIB_LOCON ("bar_wen"       ,IN        ,"bar_wen");
  GENLIB_LOCON ("ir_wen"        ,IN        ,"ir_wen");	
  GENLIB_LOCON ("dt_wen"        ,IN        ,"dt_wen");
  GENLIB_LOCON ("lo_wen"        ,IN        ,"lo_wen");
  GENLIB_LOCON ("rf_ck"         ,IN        ,"rf_ck");	
  GENLIB_LOCON ("rf_wen"        ,IN        ,"rf_wen");
  GENLIB_LOCON ("rf_selw"       ,IN        ,"rf_selw");
  GENLIB_LOCON ("rf_selr"       ,IN        ,"rf_selr");
  GENLIB_LOCON ("opx_ts7"       ,IN        ,"opx_ts7");
  GENLIB_LOCON ("opx_ts6"       ,IN        ,"opx_ts6");	
  GENLIB_LOCON ("opx_ts5"       ,IN        ,"opx_ts5");	
  GENLIB_LOCON ("opx_ts4"       ,IN        ,"opx_ts4");	
  GENLIB_LOCON ("opx_ts3"       ,IN        ,"opx_ts3");
  GENLIB_LOCON ("opx_ts2"       ,IN        ,"opx_ts2");
  GENLIB_LOCON ("opx_ts1"       ,IN        ,"opx_ts1");
  GENLIB_LOCON ("opx_ts0"       ,IN        ,"opx_ts0");
  GENLIB_LOCON ("opx_mx7"       ,IN        ,"opx_mx7");
  GENLIB_LOCON ("opx_mx6"       ,IN        ,"opx_mx6");
  GENLIB_LOCON ("opx_mx5"       ,IN        ,"opx_mx5");
  GENLIB_LOCON ("opx_mx4"       ,IN        ,"opx_mx4");
  GENLIB_LOCON ("opx_mx3"       ,IN        ,"opx_mx3");
  GENLIB_LOCON ("opx_mx2"       ,IN        ,"opx_mx2");
  GENLIB_LOCON ("opx_mx1"       ,IN        ,"opx_mx1");
  GENLIB_LOCON ("opx_sign"      ,IN        ,"opx_sign");
  GENLIB_LOCON ("crsr_dpt_out"  ,IN        ,"crsr_dpt_out");
  GENLIB_LOCON ("crsr_sts_in"   ,IN        ,"crsr_sts_in"); 
  GENLIB_LOCON ("opy_ts6"       ,IN        ,"opy_ts6");	
  GENLIB_LOCON ("opy_ts5"       ,IN        ,"opy_ts5");
  GENLIB_LOCON ("opy_ts4"       ,IN        ,"opy_ts4");
  GENLIB_LOCON ("opy_ts3"       ,IN        ,"opy_ts3");
  GENLIB_LOCON ("opy_ts2"       ,IN        ,"opy_ts2");
  GENLIB_LOCON ("opy_ts1"       ,IN        ,"opy_ts1");
  GENLIB_LOCON ("opy_mx6"       ,IN        ,"opy_mx6");
  GENLIB_LOCON ("opy_mx5"       ,IN        ,"opy_mx5");
  GENLIB_LOCON ("opy_mx4"       ,IN        ,"opy_mx4");
  GENLIB_LOCON ("opy_mx3"       ,IN        ,"opy_mx3");
  GENLIB_LOCON ("opy_mx2"       ,IN        ,"opy_mx2");
  GENLIB_LOCON ("opy_mx1"       ,IN        ,"opy_mx1");
  GENLIB_LOCON ("opy_codop"     ,IN        ,"opy_codop");
  GENLIB_LOCON ("opy_rs"        ,IN        ,"opy_rs");	
  GENLIB_LOCON ("opy_rdrt"      ,IN        ,"opy_rdrt");	
  GENLIB_LOCON ("opy_rd"        ,IN        ,"opy_rd");	
  GENLIB_LOCON ("opy_sign"      ,IN        ,"opy_sign");
  GENLIB_LOCON ("data_in_dpt"   ,IN        ,"data_in_dpt");
  GENLIB_LOCON ("alu_mx5i0"     ,IN        ,"alu_mx5i0");
  GENLIB_LOCON ("alu_mx4i0"     ,IN        ,"alu_mx4i0");
  GENLIB_LOCON ("alu_mx3i0"     ,IN        ,"alu_mx3i0");
  GENLIB_LOCON ("alu_mx2i0"     ,IN        ,"alu_mx2i0");
  GENLIB_LOCON ("alu_mx2i1"     ,IN        ,"alu_mx2i1");	
  GENLIB_LOCON ("alu_mx1i2"     ,IN        ,"alu_mx1i2");
  GENLIB_LOCON ("alu_mx1i1"     ,IN        ,"alu_mx1i1");
  GENLIB_LOCON ("alu_mx1i0"     ,IN        ,"alu_mx1i0");
  GENLIB_LOCON ("alu_mx0i0"     ,IN        ,"alu_mx0i0");
  GENLIB_LOCON ("alu_byte"      ,IN        ,"alu_byte");
  GENLIB_LOCON ("alu_half"      ,IN        ,"alu_half");
  GENLIB_LOCON ("alu_test_n"    ,IN        ,"alu_test_n");
  GENLIB_LOCON ("alu_c31"       ,IN        ,"alu_c31");	
  GENLIB_LOCON ("alu_c30"       ,IN        ,"alu_c30");
  GENLIB_LOCON ("alu_nul"       ,IN        ,"alu_nul");
  GENLIB_LOCON ("alu_sign"      ,IN        ,"alu_sign");
  GENLIB_LOCON ("data_out_dpt"  ,IN        ,"data_out_dpt");
  GENLIB_LOCON ("out_mx0i0"     ,IN        ,"out_mx0i0");	
  GENLIB_LOCON ("out_adr"       ,IN        ,"out_adr");
  GENLIB_LOCON ("alu_n_31"      ,INOUT     ,"alu_n_31");
  GENLIB_LOCON ("alu_n_1"       ,INOUT     ,"alu_n_1");
  GENLIB_LOCON ("alu_n_0"       ,INOUT     ,"alu_n_0");
  GENLIB_LOCON ("adr_n_1"       ,INOUT     ,"adr_n_1");
  GENLIB_LOCON ("adr_n_0"       ,INOUT     ,"adr_n_0");


  /* Declaration des modeles */
  /* Modifier le 31/10/00    */
  GENLIB_MACRO (DPGEN_SFFT, "model_dfft_32bits",F_PLACE, 32);
  
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_1bit",F_PLACE, 1, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_2bits",F_PLACE, 2, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_4bits",F_PLACE, 4, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_5bits",F_PLACE, 5, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_19bits",F_PLACE, 19, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_26bits",F_PLACE, 26, 2);
  GENLIB_MACRO (DPGEN_BUFF, "model_buff_32bits",F_PLACE, 32, 2);

  GENLIB_MACRO (DPGEN_MUX2, "model_mux_14bits",F_PLACE, 14, 2);
  GENLIB_MACRO (DPGEN_MUX2, "model_mux_16bits",F_PLACE, 16, 2);
  GENLIB_MACRO (DPGEN_MUX2, "model_mux_27bits",F_PLACE, 27, 2);
  GENLIB_MACRO (DPGEN_MUX2, "model_mux_32bits",F_PLACE, 32, 2);
  GENLIB_MACRO (DPGEN_NMUX2, "model_nmux_32bits",F_PLACE, 32, 2);
  
  GENLIB_MACRO (DPGEN_OR2, "model_or2_32bits",F_PLACE, 32, 2);
  GENLIB_MACRO (DPGEN_AND2, "model_and2_32bits",F_PLACE, 32, 2);
  GENLIB_MACRO (DPGEN_XOR2, "model_xor2_32bits",F_PLACE, 32, 4);
  GENLIB_MACRO (DPGEN_NOR2, "model_nor2_32bits",F_PLACE, 32, 4);


  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX00000000_32bits",F_PLACE, 32, 0x00000000);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constXFFFFFFFF_32bits",F_PLACE, 32, 0xFFFFFFFF);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX0000FFFF_32bits",F_PLACE, 32, 0x0000FFFF);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX80000080_32bits",F_PLACE, 32, 0x80000080);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX00000018_32bits",F_PLACE, 32, 0x00000018);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constXBFC00000_32bits",F_PLACE, 32, 0xBFC00000);
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX00000010_32bits",F_PLACE, 32, 0x00000010);   
  GENLIB_MACRO (DPGEN_CONST, 
		"model_constX00000004_32bits",F_PLACE, 32, 0x00000004);  

  GENLIB_MACRO (DPGEN_INV, "model_inv_32bits", F_PLACE, 32,2);
  GENLIB_MACRO (DPGEN_NBUSE, "model_nbuse_32bits",F_PLACE, 32);
  GENLIB_MACRO (DPGEN_BUSE, "model_buse_32bits",F_PLACE, 32);
  GENLIB_MACRO (DPGEN_SHIFT, "model_shift_32bit", F_PLACE, 32);
  GENLIB_MACRO (DPGEN_ADSB2F,"model_adsb2f_32bits", F_PLACE, 32);

  /*********************** REGISTRE DU CHEMIN DE DONNEES ************************/
  /* Declaration des constantes */
  /* 02/11/00 */
  GENLIB_LOINS ("model_constX00000000_32bits",
		"const000000000_32bits",
		"s_constX00000000_32bits",
		"vdd", "vss", NULL);
    
  GENLIB_LOINS ("model_constXFFFFFFFF_32bits",
		"constXFFFFFFFF_32bits",
		"s_constXFFFFFFFF_32bits",
		"vdd", "vss", NULL);
    
  GENLIB_LOINS ("model_constX80000080_32bits",
		"constX80000080_32bits",
		"s_constX80000080_32bits",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_constX00000018_32bits",
		"constX000000018_32bits",
		"s_constX00000018_32bits",
		"vdd", "vss", NULL);
    
  GENLIB_LOINS ("model_constXBFC00000_32bits",
		"constXBFC00000_32bits",
		"s_constXBFC00000_32bits",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_constXBFC00000_32bits",
		"constXBFC00000_32bits",
		"s_constXBFC00000_32bits",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_constX00000010_32bits",
		"constX00000010_32bits",
		"s_constX00000010_32bits",
		"vdd", "vss", NULL);
  
  
  /* commande de l'alutest */
  GENLIB_LOINS("model_buff_1bit",
	       "buff_1bit_alu1",
	       "alu_test_n",
	       "alutestn2",
	       "vdd", "vss", NULL);
  
  GENLIB_LOINS("model_buff_1bit",
	       "buff_1bit_alu2",
		  "alu_cry[32]",
		  "alu_cry2",
		  "vdd", "vss", NULL);

    
     GENLIB_LOINS("model_inv_32bits",
		  "inv_data_in_dpt",
		  "data_in_dpt[31:0]",
		  "data_in_n[31:0]",
                  "vdd", "vss", NULL);

/*********************** Description OPERANDE X **************************/
     /*modifie le 2/11/00 */
 
 GENLIB_LOINS("model_buff_32bits",
		  "buff_32bits_opx_ots",
		  "opx_ots[31:0]",
		  "opx_out[31:0",
		  "vdd", "vss", NULL);
  

 GENLIB_LOINS("model_buff_1bit",
	      "buff_1bit_opx_out_31",
	      "opx_out[31]",
	      "opx_sign",
	      "vdd", "vss", NULL);

 GENLIB_LOINS("model_buff_32bits",
	      "buff_32bit_pc_s",
	      "pc_s[31:28]","s_constX00000000[27:0]",  // Concatenation de pc_s & X0000000
	      "pc4[31:0]",
	      "vdd", "vss", NULL);
 
 
 /* multiplexeurs avant les emetteurs tri-states pour X */
 GENLIB_LOINS ( "model_nmux_32bits",
                "nmux_opx_mx7",
                "opx_mx7",
                "pc4[31:0]",
                "s_constX00000000[31:0]",   //signal en entree XFFFFFFFF
                "opx_its7[31:0]",
                "vdd", "vss", NULL);

 GENLIB_LOINS ( "model_nmux_32bits",
                "nmux_opx_mx6",
                "opx_mx6",
                "dt_s[31:0]",
                "s_constX0000FFFF[31:0]", // entree XFFFF0000
                "opx_its6[31:0]",
                "vdd", "vss", NULL);
 
 GENLIB_LOINS ("model_nmux_32bits",
	       "nmux_opx_mx5",
	       "opx_mx5",
	       "s_constX00000000[31:0]", //entree XFFFFFFFF
	       "s_constX80000080[31:0]",  //entree X7FFFFF7F
	       "opx_its5[31:0]",
	       "vdd", "vss", NULL);
 
 
  GENLIB_LOINS ("model_nmux_32bits",
                "nmux_opx_mx4",
                "opx_mx4",
                "bar_s[31:0]",
                "epc_s[31:0]",
                "opx_its4[31:0]",
                "vdd", "vss", NULL);
  
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opx_mx3",
		 "opx_mx3",
		 "sr_s[31:0]",
		 "cr_s[31:0]",
		 "opx_its3[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opx_mx2",
		 "opx_mx2",
		 "hi_s[31:0]",
		 "lo_s[31:0]",
		 "opx_its2[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opx_mx1",
		 "opx_mx1",
		 "pc_s[31:0]",
		 "ad_s[31:0]",
		 "opx_its1[31:0]",
		 "vdd", "vss", NULL);
  

/*****les emetteurs tri-states pour X ***/
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts7",
		 "opx_ts7",
		 "opx_its7[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts6",
		 "opx_ts6",
		 "opx_its6[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);

  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts5",
		 "opx_ts5",
		 "opx_its5[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts4",
		 "opx_ts4",
		 "opx_its4[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts3",
		 "opx_ts3",
		 "opx_its3[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);

  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts2",
		 "opx_ts2",
		 "opx_its2[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
 
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opx_ts1",
		 "opx_ts1",
		 "opx_its1[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_buse_32bits",
		 "buse_opx_ts0",
		 "opx_ts0",
		 "rf_s[31:0]",
		 "opx_ots[31:0]",
		 "vdd", "vss", NULL);
  
/****************************** Y operand description *************************/
  /* le 02/11/00 */
  GENLIB_LOINS ("model_buff_19bits",     
		"buff_opy_codop",
                "ir_s[31:26]",
                "ir_s[25]",
                "ir_s[23]",
                "ir_s[13:11]",
                "ir_s[16]",
                "ir_s[20]",
                "ir_s[5:0]" 
                "opy_codop[18:0]",
                "vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_5bits",
		"buff_opy_rs",
		"ir_s[25:21]",
		"opy_rs[4:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_5bits",
		"buff_opy_rdrt",
		"ir_s[20:16]",
		"opy_rdrt[4:0]",
		"vdd", "vss", NULL);

  GENLIB_LOINS ("model_buff_5bits",
		"buff_opy_rd",
		"ir_s[15:11]",
		"opy_rd[4:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_5bits",
		"buff_opy_shamt",
		"ir_s[10:6]",
		"opy_shamt[4:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_mux_27bits",
		"mux_opy_shamt",
		"ir_s[10]"         //cmd ir_s(10)
		"s_constX00000000[26:0]",  //! X000000 & B000
		"s_constXFFFFFFFF[26:0]",     //  XFFFFFF & B111
		"opy_shamt[31:5]"
		"vdd", "vss", NULL);

  GENLIB_LOINS ("model_buff_16bits",
		"buff_opy_ir16",
		"ir_s[15:0]",
		"opy_ir16[15:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_mux_16bits",
		"mux_opy_ir16",
		"ir_s[15]"         //cmd ir_s(15)
		"s_constX00000000[15:0]",  //! X0000
		"s_constXFFFFFFFF[15:0]",  //XFFFF
		"opy_ir16[15:0]",
		"vdd", "vss", NULL);
  
  
  GENLIB_LOINS ("model_buff_2bits",
		"buff_opy_ir18",
		"s_constX00000000[1:0]",  //B00
		"opy_ir18[1:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_16bits",
		"buff_opy_ir18_2",
		"ir_s[15:0]",  
		"opy_ir18[17:2]",
		"vdd", "vss", NULL);

  GENLIB_LOINS ("model_mux_14bits",
		"mux_opy_ir18",
		"ir_s[15]"         //cmd ir_s(15)
		"s_constX00000000[13:0]",  //! X000 &B00
		"s_constXFFFFFFFF[13:0]",  //XFFF & B11
		"opy_ir18[31:18]",
		"vdd", "vss", NULL);

  GENLIB_LOINS ("model_buff_2bits",
		"buff_opy_iru28",
		"s_constX00000000[1:0]",  //B00
		"opy_iru28[1:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_26bits",
		"buff_opy_iru28_2",
		"ir_s[25:0]",  //B00
		"opy_iru28[27:2]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_4bits",
		"buff_opy_iru28_3",
		"s_constX00000000[3:0]",  //B00
		"opy_iru28[31:28]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_inv_32bits",  
		"inv_data_in",
		"data_in_n[31:0]",
		"opy_dt",
		"vdd", "vss", NULL);
  
  /* Selection des commandes par les multiplexeurs */
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_its6",
		 "opy_mx6",
		 "s_constX00000008[31:0]",
		 "s_constX00000018[31:0]",
		 "opy_its6[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_mx5",
		 "opy_mx5",
		 "opy_shamt[31:0]",
		 "s_constXBFC00000[31:0]",
		 "opy_its5[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_mx4",
		 "opy_mx4",
		 "s_constX00000004[31:0]",
		 "s_constX00000010[31:0]",
		 "opy_its4[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_mx3",
		 "opy_mx3",
		 "opy_ir16[31:0]",
		 "s_constX00000000[31:0]",
		 "opy_its3[31:0]",
		 "vdd", "ss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_mx2",
		 "opy_mx2",
		 "opy_iru28[31:0]",
		 "opy_ir18[31:0]",
		 "opy_its2[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nmux_32bits",
		 "nmux_opy_mx1",
		 "opy_mx1",
		 "ad_s[31:0]",
		 "dt_s[31:0]",
		 "opy_its1[31:0]",
		 "vdd", "vss", NULL);
  
  /* Porte tristates de l'operande Y */
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its6",
		 "opy_ts6",
		 "opy_its6[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);

  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its5",
		 "opy_ts5",
		 "opy_its5[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its4",
		 "opy_ts4",
		 "opy_its4[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its3",
		 "opy_ts3",
		 "opy_its3[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its2",
		 "opy_ts2",
		 "opy_its2[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);

  GENLIB_LOINS ( "model_nbuse_32bits",
		 "nbuse_opy_its1",
		 "opy_ts1",
		 "opy_its1[31:0]",
		 "opy_ots[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_32bits",
		"buff_opy_out",
		"opy_ots[31:0]",
		"opy_out[31:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_buff_1bit",
		"buff_opy_sign",
		"opy_ots[31]", 
		"opy_sign",
		"vdd", "vss", NULL);

  /**************  alu shifter description   *********************************/


  GENLIB_LOINS ("inv_x1",
		"inv_alu_shift",
		"alu_mx2i0",
		"e2_shift",
		"vdd","vss",NULL);
  
  GENLIB_LOINS ("model_shift_32bit",
		"shift_alu",
		"alu_mx1i0",
		"e2_shift",
		"opy_out[4:0]",
		"opx_out[31:0]",
		"alu_shout[31:0]",
		"vdd", "vss", NULL);

/***************** ALU arytmetic Operations Description *********/


  GENLIB_LOINS ("model_or2_32bit",
		"alu_or2_32bits",
		"opx_x[31:0]",
		"opy_y[31:0]",
		"s_alu_or2[31,0]",
		"vdd", "vss", NULL);
  
  
  GENLIB_LOINS ("model_and2_32bit",
		"alu_and2_32bits",
		"opx_x[31:0]",
		"opy_y[31:0]",
		"s_alu_and2[31:0]",
		"vdd", "vss", NULL);
  
  
  GENLIB_LOINS ("model_xor2_32bit",
		"alu_xor2_32bits",
		"opx_x[31:0]",
		"opy_y[31:0]",
		"s_alu_xor2[31:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_nor2_32bit",
		"alu_nor2_32bits",
		"opx_x[31:0]",
		"opy_y[31:0]",
		"alu_nor[31:0]",
		"vdd", "vss", NULL);
  
  GENLIB_LOINS ("model_adsb2f_32bits",
		"addsub_32bits",
		"alu_mx0i0",            //add = 0 ; sub = 1
		"alu_c31",              //carry
		"alu_c30",             //overflow
		"opx_out[31:0]",
		"opy_out[31:0]",
		"alu_sum[31:0]",
		"vdd", "vss", NULL);
  
/******************* selection de l'ALU **********************/
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_sum_nor",
		 "alu_mx2i1",
		 "alu_sum[31:0]",
		 "alu_nor[31:0]", 
		 "mux_alu_sum_nor_s[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_or_and",
		 "alu_mx1i2",
		 "s_alu_and2[31:0]",           //select AND
		 "s_alu_or2[31:0]",            //select OR
		 "mux_alu_or_and_s[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_xor",
		 "alu_mx2i1",
		 "s_alu_xor2[31:0]",         //select XOR
		 "mux_alu_or_and_s[31:0]",
		 "mux_alu_xor_s[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_xor_sum",
		 "alu_mx3i0",
		 "mux_alu_sum_nor_s[31:0]",
		 "mux_alu_xor_s[31:0]",
		 "mux_alu_xor_sum_s[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_shout",
		 "alu_mx4i0",
		 "mux_alu_xor_sum_s[31:0]",
		 "alu_shout[31:0]",
		 "mux_alu_shunt_s[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_inv_32bits",
		 "inv_alu_test",
		 "alu_test_n[31:0]",
		 "not_alu_test_n[31:0]",
		 "vdd", "vss", NULL);
  
  GENLIB_LOINS ( "model_mux_32bits",
		 "mux_alu_test",
		 "alu_mx5i0",
		 "mux_alu_shunt_s[31:0]",
		 "s_constX00000000_32bits[27:0]","s_constX00000000_32bits[2:0]","not_alu_test_n",
		 "alu_out[31:0]",
		 "vdd", "vss", NULL);
  
/***************** ADROUT Multiplexer Description  *****************/












/***************************** REGISTRES ****************************/
 /* Modifier le 31/10/00    */

    /* Buffer de sortie du PC */              //buff_1bit_PC2 
    GENLIB_LOINS("model_buff_1bit",            
		 "buff_1bit_PC2",
		 "pc_s[31]",
		 "pc_scout",
		 "vdd", "vss", NULL);    

    /* Registre du PC */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_PC",
		 "pc_test",
		 "pc_scin",
		 "pc_wen",
		 "pc_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);    

    /* Registre de EPC */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_EPC",
		 "epc_test",
		 "epc_scin",
		 "epc_wen",
		 "epc_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    /* Registre de BAR */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_BAR",
		 "bar_test",
		 "bar_scin",
		 "bar_wen",
		 "bar_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);   

    /* Registre de AD */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_AD",
		 "ad_test",
		 "ad_scin",
		 "ad_wen",
		 "ad_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    /* Registre de HI */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_HI",
		 "hi_test",
		 "hi_scin",
		 "hi_wen",
		 "hi_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    /* Registre de LO */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_LO",
		 "lo_test",
		 "lo_scin",
		 "lo_wen",
		 "lo_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    /* Registre DT */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_DT",
		 "dt_test",
		 "dt_scin",
		 "dt_wen",
		 "dt_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    /* Registre IR */ 
    GENLIB_LOINS("model_dfft_32bits",
		 "dfft_IR",
		 "ir_test",
		 "ir_scin",
		 "ir_wen",
		 "ir_ck",
		 "alu_out",
		 "pc_s",
		 "vdd", "vss", NULL);

    GENLIB_SAVE_LOFIG();
    exit(0);
}
