//*************************************************************
// Ejemplo 1
// Generacion de Patrones de prueba para el decodificador 2 a 4

// Archivo : decoder.c
// Autor   : Andres Farfan P
// Fecha   : Marzo 28 de 1999
//*************************************************************


#include <stdio.h>
#include <genpat.h>


char *int2str(int entero)
{ 
     char *str;
     str = (char *) mbkalloc( 32 * sizeof(char));
     sprintf( str, "%d", entero);
     return(str);
}

//**********************************************************************	
	

int main(void)
{
     int i;


     //Nombre de archivo de salida
     DEF_GENPAT("decoder_genpat");

     //Declaracion de entradas/salidas

     DECLAR("vdd", ":2", "B", IN, "","");
     DECLAR("vss", ":2", "B", IN, "","");
     DECLAR("vsse",":2", "B", IN, "","");
     DECLAR("vdde",":2", "B", IN, "","");

     DECLAR("A", ":2", "B", IN, "1 DOWNTO 0","");
   
     DECLAR("Y", ":2", "B", OUT, "3 DOWNTO 0","");


     //Generar los patrones de simulacion
     AFFECT(int2str(0), "vdd", "0b1");
     AFFECT(int2str(0), "vss", "0b0");
     AFFECT(int2str(0), "vdde","0b1");
     AFFECT(int2str(0), "vsse","0b0"); 

     for(i=0;i<4;i++)
     {
         LABEL("pat");
         AFFECT (int2str(i), "A", int2str(i));
     }


    //Guardar el archivo generado
    SAV_GENPAT();

    //Retornar 
    exit(0);
}
     	
     
